var gulp = undefined;
var babel = require('./babel');
var changed = require('gulp-changed');
var plumber = require('gulp-plumber');
var gutil = require('gulp-util');
var watch = require('gulp-watch');

var babelTask = function (opts) {
  opts = opts || {};
  return function() {
    var src = 'src/**/*.js';
    var task = gulp.src(src);
    if (opts.watch) {
      task = task
      .pipe(plumber())
      .pipe(watch(src))
      ;
    }
    task = task
      .pipe(changed(paths.dest))
      .pipe(sourcemaps.init())
      .pipe(babel({
        stage: 1,
        blacklist: [
          'es6.constants',
          'es6.forOf',
          'es6.spec.symbols',
          'es6.spec.templateLiterals',
          'es6.templateLiterals',
        ],
        optional: [
          'asyncToGenerator',
          'runtime',
        ],
      }))
      .pipe(sourcemaps.write(paths.sourceMaps))
      ;
    if (opts.watch) {
      task = task
      .pipe(plumber.stop())
      ;
    }
    task = task
      .pipe(gulp.dest(paths.dest));
    return task;
  };
}

module.exports = function (_gulp, opts) {
  gulp = _gulp;
  module.exports.gulp = gulp;
  opts = opts || {};
  if (opts.createTasks) {
    gulp.task('babel', babelTask());
    gulp.task('babel-watch', babelTask({watch: true}));
  }
  return module.exports;
};

module.exports.babelTask = babelTask;
